﻿using DevExpress.XtraMap;

namespace TestProject
{
    /// <summary>
    /// 지오코드 데이터 공급자
    /// </summary>
    public class GeocodeDataProvider : InformationDataProviderBase, IMouseClickRequestSender
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 데이터 - Data

        /// <summary>
        /// 데이터
        /// </summary>
        protected new GeocodeData Data
        {
            get
            {
                return (GeocodeData)base.Data;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - GeocodeDataProvider()

        /// <summary>
        /// 생성자
        /// </summary>
        public GeocodeDataProvider()
        {
            ProcessMouseEvents = true;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 포인트 요청하기 - RequestByPoint(geoPoint, screenPoint)

        /// <summary>
        /// 포인트 요청하기
        /// </summary>
        /// <param name="geoPoint">지리 포인트</param>
        /// <param name="screenPoint">화면 포인트</param>
        public void RequestByPoint(GeoPoint geoPoint, MapPoint screenPoint)
        {
            Data.CalculateAddress(geoPoint);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 데이터 생성하기 - CreateData()

        /// <summary>
        /// 데이터 생성하기
        /// </summary>
        /// <returns>정보 데이터 인터페이스</returns>
        protected override IInformationData CreateData()
        {
            return new GeocodeData();
        }

        #endregion
    }
}